#!/usr/bin/python
# -*- coding: utf-8 -*-
import gtk,os,webbrowser

        
def crea_b_img(img,text,w,h,stock):
    #stock=0 immagine da file
    #stock=1 immagine da stock
    
    button = gtk.Button()
    image = gtk.Image()
    if stock==0:
        image.set_from_file(img)
    else:
        image.set_from_stock(img,gtk.ICON_SIZE_SMALL_TOOLBAR)
    button.set_image(image)
    button.set_label(text)
    button.set_size_request(w,h)

    return button

def new_item_menu(agr,img_menu,str_key,label,toolbar_on,toolbar_off,status):
    if img_menu==None:
        newi = gtk.MenuItem("")
    else:
        newi = gtk.ImageMenuItem(img_menu, agr)

    if str_key=="":
        pass
    else:
        key, mod = gtk.accelerator_parse(str_key)
        newi.add_accelerator("activate", agr, key, mod, gtk.ACCEL_VISIBLE)

    newi.child.set_label(label)
    newi.connect("select", push_item,toolbar_on,status)
    newi.connect("deselect", push_item,toolbar_off,status)
    
    return newi
   
def push_item( widget, data,status):
    status.push(1,data)

#def crea_avviso(parent,testo):
def crea_avviso(testo):
    icon =os.path.join("img","ico_family.ico")
    
    image=gtk.Image()
    
    image.set_from_stock(gtk.STOCK_DIALOG_WARNING,gtk.ICON_SIZE_SMALL_TOOLBAR)

    msg_box = gtk.Window(gtk.WINDOW_TOPLEVEL)
#    msg_box.set_transient_for(parent)
    msg_box.set_position(gtk.WIN_POS_CENTER_ALWAYS)
    msg_box.set_title("Attenzione!")
    msg_box.set_resizable(False)
    msg_box.set_icon_from_file(icon)        

    hbox=gtk.HBox()
    hbox_btn=gtk.HBox()
    vbox=gtk.VBox()
    msg_box.add(vbox)
    vbox.pack_start(hbox,False,False,5)
    vbox.pack_start(hbox_btn,False,False,5)

    label_testo=gtk.Label(testo)

    hbox.pack_start(image,False,False,5)
    hbox.pack_start(label_testo,False,False,5)

    btn_ok = crea_b_img(gtk.STOCK_OK,"Ok",100,35,1)
    btn_ok.connect("clicked", chiudi_avviso,msg_box)

    hbox_btn.pack_end(btn_ok,False,False,5)

    msg_box.set_modal(True)
    msg_box.show_all()

def chiudi_avviso(widget,chi):
    chi.destroy()


