#!/usr/bin/python
# -*- coding: utf-8 -*-
__author__="Krypt"
__date__ ="$05-jen-2010 18.00.00$"
import gtk,os,webbrowser,operator,string
from mod.grafica import *
from xml.dom import minidom
from xml.dom.minidom import Document


global aggiunto
aggiunto=0

def About_Info2(self,root):
    about = gtk.AboutDialog()
    about.set_transient_for(self)
    about.set_position(gtk.WIN_POS_CENTER_ON_PARENT)
    about.set_name("Family Cash")
    about.set_version("1.0")
    about.set_copyright("(c) Marco Crippa")
    about.set_comments("Semplice programma per la gestione del bilancio familiare")
    about.set_website("http://krypt77.altervista.org/")
    splash = os.path.join(root,"img","info.png")
    about.set_logo(gtk.gdk.pixbuf_new_from_file(splash))
    about.run()
    about.destroy()

def on_url(d,link,data):
    webbrowser.open("http://krypt77.altervista.org/")
        
gtk.about_dialog_set_url_hook(on_url,None)

def About_Setting2(self,ar_categorie,root):
	self.fin_opzioni = gtk.Window(gtk.WINDOW_TOPLEVEL)

	self.fin_opzioni.set_size_request(680, 580)
	self.fin_opzioni.set_position(gtk.WIN_POS_CENTER)
	self.fin_opzioni.set_resizable(False)
	self.fin_opzioni.set_deletable(False)
	self.fin_opzioni.connect("destroy", Chiudi_Opzioni,self.fin_opzioni)
	self.fin_opzioni.set_title("Opzioni")
	self.fin_opzioni.set_icon_from_file(self.icon)        

	vbox=gtk.VBox(False, 0)

	#titolo
	tit=gtk.Label("Elenco categorie utilizzate")
	vbox.pack_start(tit, False, False, 5)

	#separatore H
	vbox.pack_start(gtk.HSeparator(), False, False, 5)

	#carico elenco categorie
	sw_cat = gtk.ScrolledWindow()
	sw_cat.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
	sw_cat.set_size_request(550, 250)
	tv_cat,store=Carica_Categorie(self,root)
	sw_cat.add_with_viewport(tv_cat)
	vbox.pack_start(sw_cat, False, False, 0)

	#separatore H
	vbox.pack_start(gtk.HSeparator(), False, False, 10)

	#box categorie
	box_cat=gtk.HBox(False, 0)

	box_img=gtk.VBox(False, 5)
	img_cat=gtk.Image()
	img_cat.set_from_file(os.path.join(root,"img","ico_generica.png"))
	but_img=gtk.Button("Seleziona l\'icona (25px X 25px)")
	but_img.connect("clicked", Scegli_Icona,self.fin_opzioni,img_cat,root)
	box_img.pack_start(but_img, False, False, 0)
	box_img.pack_start(img_cat, False, False, 0)

	box_nome=gtk.VBox(False, 5)
	l_nome=gtk.Label("Inserisci il nome della categoria: ")
	nome_cat=gtk.Entry()
	box_nome.pack_start(l_nome, False, False, 0)
	box_nome.pack_start(nome_cat, False, False, 0)

	box_tipo=gtk.VBox(False, 5)
	box_tipo2=gtk.HBox(False, 5)
	l_cat=gtk.Label("Imposta il tipo di categoria: ")
	uscita = gtk.RadioButton(None, "uscita")
	box_tipo2.pack_start(uscita, False, False, 0)
	entrata = gtk.RadioButton(uscita, "entrata")
	box_tipo2.pack_start(entrata, False, False, 0)
	box_tipo.pack_start(l_cat, False, False, 0)
	box_tipo.pack_start(box_tipo2, False, False, 0)

	box_cat.pack_start(box_img, False, False, 0)
	box_cat.pack_start(gtk.VSeparator(), False, False, 10)
	box_cat.pack_start(box_nome, False, False, 0)
	box_cat.pack_start(gtk.VSeparator(), False, False, 10)
	box_cat.pack_start(box_tipo, False, False, 10)
	vbox.pack_start(box_cat, False, False, 0)

	#bottone per aggiungere la categoria
	btn_agg_cat=crea_b_img(gtk.STOCK_ADD,"Aggiungi la categoria",200,40,1)
	vbox.pack_start(btn_agg_cat, False, False, 5)

	#separatore H
	vbox.pack_start(gtk.HSeparator(), False, False, 10)

	#settaggio della valuta	
	box_v=gtk.VBox(False, 5)
	box_valuta=gtk.HBox(True, 5)
	l_val=gtk.Label("Imposta la valuta")
	euro = gtk.RadioButton(None, "€ euro")
	box_valuta.pack_start(euro, False, False, 0)
	dollaro = gtk.RadioButton(euro, "$ dollaro")
	box_valuta.pack_start(dollaro, False, False, 0)
	sterlina = gtk.RadioButton(euro, "£ sterlina")
	box_valuta.pack_start(sterlina, False, False, 0)
	box_v.pack_start(l_val, False, False, 0)
	box_v.pack_start(box_valuta, False, False, 0)
	vbox.pack_start(box_v, False, False, 5)

	#separatore H
	vbox.pack_start(gtk.HSeparator(), False, False, 10)

	#bottoni ok e cancel
	box_btn=gtk.HBox(True, 5)
	btn_cancel=crea_b_img(gtk.STOCK_CANCEL,"Annulla",200,40,1)
	btn_cancel.connect("clicked", Chiudi_Opzioni,self.fin_opzioni)
	btn_ok=crea_b_img(gtk.STOCK_OK,"OK",200,40,1)
	btn_ok.connect("clicked", Salva_Opzioni,self.fin_opzioni,tv_cat,euro,root)
	box_btn.pack_start(btn_cancel, False, False, 5)
	box_btn.pack_start(btn_ok, False, False, 5)
	vbox.pack_start(box_btn, False, False, 10)

	btn_agg_cat.connect("clicked", Inserisci_Nuova_Categoria,img_cat,nome_cat,uscita,store,tv_cat,root)

	self.fin_opzioni.add(vbox)
	self.fin_opzioni.set_modal(True)
	self.fin_opzioni.show_all()

def Carica_Categorie(self,root):
	#creo il modello dei totali
	store = gtk.ListStore(gtk.gdk.Pixbuf, str, str, str)	
	tv_cat = gtk.TreeView(store)
	#	tv_totali = gtk.TreeView(tms_totali)
	tv_cat.set_rules_hint(True)
	tv_cat.set_grid_lines(gtk.TREE_VIEW_GRID_LINES_BOTH)
	#creo le celle
	cell_img = gtk.CellRendererPixbuf()
	cell_text = gtk.CellRendererText()
	#creo le colonne dei totali
	c_img = gtk.TreeViewColumn("Icona categoria", cell_img, pixbuf=0)
	c_img.set_expand(False)
	tv_cat.append_column(c_img)
	c_img_nome = gtk.TreeViewColumn("File icona", cell_text, text=1)
	c_img_nome.set_expand(True)
	tv_cat.append_column(c_img_nome)
	c_nome = gtk.TreeViewColumn("Nome categoria", cell_text, text=2)
	c_nome.set_expand(True)
	tv_cat.append_column(c_nome)
	c_tipo = gtk.TreeViewColumn("Tipo", cell_text, text=3)
	c_tipo.set_expand(False)
	tv_cat.append_column(c_tipo)

	file_pref = minidom.parse(os.path.join(root,"settings","preferences.stx"))
	cat_uscita = file_pref.getElementsByTagName('cat_uscita')[0].childNodes
	for i in range (0,len(cat_uscita)):
		if cat_uscita[i].nodeType==3:
		    pass
		else:
			img = gtk.gdk.pixbuf_new_from_file(os.path.join(root,"img",cat_uscita[i].getAttribute("img")))
			store.append([img,cat_uscita[i].getAttribute("img"),cat_uscita[i].getAttribute("nome"),cat_uscita[i].getAttribute("valore")])

	cat_entrata = file_pref.getElementsByTagName('cat_entrata')[0].childNodes
	for i in range (0,len(cat_entrata)):
		if cat_entrata[i].nodeType==3:
		    pass
		else:
			img = gtk.gdk.pixbuf_new_from_file(os.path.join(root,"img",cat_entrata[i].getAttribute("img")))
			store.append([img,cat_entrata[i].getAttribute("img"),cat_entrata[i].getAttribute("nome"),cat_entrata[i].getAttribute("valore")])
			
	file_pref.unlink()
			
	return tv_cat,store

def Scegli_Icona(self,parent,img_cat,root):
	fin = gtk.FileChooserDialog("Scegli l\'icona...",None,gtk.FILE_CHOOSER_ACTION_OPEN,(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK))
	fin.set_default_response(gtk.RESPONSE_OK)
	fin.set_current_folder(os.path.join(root,"img"))
	fin.set_transient_for(parent)
	fin.set_position(gtk.WIN_POS_CENTER_ON_PARENT)
	fin.set_icon_from_file(os.path.join(root,"img","ico_family.ico"))        
	filter = gtk.FileFilter()
	filter.set_name("Immagine PNG (*.png)")
	filter.add_pattern("*.png")
	fin.add_filter(filter)
	filter = gtk.FileFilter()
	filter.set_name("Tutti i file")
	filter.add_pattern("*")
	fin.add_filter(filter)
	response = fin.run()

	if response == gtk.RESPONSE_OK:
		archivio_temp = fin.get_filenames()
		file_img=archivio_temp[0]
		img_cat.set_from_file(file_img)

	elif response == gtk.RESPONSE_CANCEL:
		fin.destroy()
	fin.destroy()

def Tipo(tipo):

	for i in xrange(0,len(tipo.get_group())):
		if tipo.get_group()[i].get_active():
			valore=tipo.get_group()[i].get_label()
	return valore

def Inserisci_Nuova_Categoria(self,img_cat,nome_cat,uscita,store,tv_cat,root):
	global aggiunto

	nome_categoria=nome_cat.get_text()

	tm=tv_cat.get_model()
	num_row=0

	if nome_categoria!="":
		for row in tm:
			if tm[num_row][1]==nome_categoria:
				msg="ATTENZIONE!\nLa categoria\n"+nome_categoria+"\nesiste già!"
				msg_box=gtk.MessageDialog(None, 0, gtk.MESSAGE_INFO, gtk.BUTTONS_CLOSE, msg)
				response = msg_box.run()
				agg=0
				if response == gtk.RESPONSE_CLOSE:
					msg_box.destroy()
					break
			else:
				agg=1
			num_row=num_row+1
		if agg==1:
			nome_img=os.path.split(img_cat.get_property("file"))[1]
			cat=Tipo(uscita)
			img = gtk.gdk.pixbuf_new_from_file(os.path.join(root,"img",nome_img))
			store.append([img,nome_img,nome_categoria,cat])
			aggiunto=1
			return aggiunto
	else:
		msg="ATTENZIONE!\nInserisci un nome della categoria."
		msg_box=gtk.MessageDialog(None, 0, gtk.MESSAGE_INFO, gtk.BUTTONS_CLOSE, msg)
		response = msg_box.run()
		if response == gtk.RESPONSE_CLOSE:
		    msg_box.destroy()
		else:
		    pass
		msg_box.destroy()


def Salva_Opzioni(self,fin,tv_cat,euro,root):
	global aggiunto

	if aggiunto==1:
		val=Tipo(euro)

		tm=tv_cat.get_model()
		num_row=0

		ar_u=[]
		ar_e=[]
		for row in tm:
			if tm[num_row][3]=="uscita":
				ar_u.append([tm[num_row][1],tm[num_row][2],tm[num_row][3]])
			else:
				ar_e.append([tm[num_row][1],tm[num_row][2],tm[num_row][3]])
			num_row=num_row+1

		ar_u=sorted(ar_u, key=operator.itemgetter(1))
		ar_e=sorted(ar_e, key=operator.itemgetter(1))

		doc = Document()

		opzioni = doc.createElement("opzioni")
		doc.appendChild(opzioni)

		categorie = doc.createElement("categorie")
		opzioni.appendChild(categorie)

		cat_uscita = doc.createElement("cat_uscita")
		categorie.appendChild(cat_uscita)

		for a in xrange(0,len(ar_u)):
			categoria = doc.createElement("categoria")
			categoria.setAttribute("img", ar_u[a][0])
			categoria.setAttribute("nome", ar_u[a][1])
			categoria.setAttribute("valore", ar_u[a][2])
			cat_uscita.appendChild(categoria)

		cat_entrata = doc.createElement("cat_entrata")
		categorie.appendChild(cat_entrata)

		for a in xrange(0,len(ar_e)):
			categoria = doc.createElement("categoria")
			categoria.setAttribute("img", ar_e[a][0])
			categoria.setAttribute("nome", ar_e[a][1])
			categoria.setAttribute("valore", ar_e[a][2])
			cat_entrata.appendChild(categoria)

		tipo_valuta = doc.createElement("valuta")
		tipo_valuta.setAttribute("simbolo", string.split(val," ")[0])
		opzioni.appendChild(tipo_valuta)
	
		file_op = (os.path.join(root,"settings","preferences.stx"))
		file_op_temp = open(file_op,'w')
		file_op_temp.write(doc.toprettyxml(indent="  "))
		file_op_temp.close()

		msg="ATTENZIONE!\nDevi riavviare il programma per rendere effettive le modifiche."
		msg_box=gtk.MessageDialog(None, 0, gtk.MESSAGE_INFO, gtk.BUTTONS_CLOSE, msg)
		response = msg_box.run()
		if response == gtk.RESPONSE_CLOSE:
		    msg_box.destroy()
		else:
		    pass
		msg_box.destroy()


	Chiudi_Opzioni(self,fin)
	aggiunto=0

def Chiudi_Opzioni(self,fin):
    fin.set_modal(False)
    fin.destroy()
    
def About_Manuale2(self,root):

	webbrowser.open(os.path.join(root,"help","help.htm"))
	

