#!/usr/bin/python
# -*- coding: utf-8 -*-
__author__="Krypt"
__date__ ="$05-jen-2010 18.00.00$"

import gtk,os,sys,gobject
from mod.grafica import *
from mod.op_file import *
from mod.op_anno_mese import *
from mod.setting import *
from mod.insert import *
from xml.dom import minidom
from xml.dom.minidom import Document

global aperto
global ar_categorie
global ar_cat_uscita
global ar_cat_entrata
global model_combo_cat
global file_family
global valuta
global nuovo
global root

#print 'sys.argv[0] =', sys.argv[0]             
pathname = os.path.dirname(sys.argv[0])        
#print 'path =', pathname
#print 'full path =', os.path.abspath(pathname)
root=os.path.abspath(pathname)

gtk.rc_parse(os.path.join(root,"settings","Family_style"))

nuovo=0
aperto=0
file_family=""
model_combo_cat=""
ar_categorie = []
ar_cat_uscita = []
ar_cat_entrata = []

#INIZIO caricamento VALUTA
def Carica_Valuta():
    global root
    file_pref = minidom.parse(os.path.join(root,"settings","preferences.stx"))
    valuta = file_pref.getElementsByTagName('valuta')[0].getAttribute("simbolo")
    file_pref.unlink()    
    return valuta
#FINE caricamento VALUTA

#INIZIO caricamento file categorie
def Carica_Categorie():
    global root
    ar_cat_uscita2=[]
    ar_cat_entrata2=[]
    
    file_pref = minidom.parse(os.path.join(root,"settings","preferences.stx"))
    cat_uscita = file_pref.getElementsByTagName('cat_uscita')[0].childNodes
    for i in range (0,len(cat_uscita)):
        if cat_uscita[i].nodeType==3:
            pass
        else:
            ar_cat_uscita2.append([cat_uscita[i].getAttribute("img"),cat_uscita[i].getAttribute("nome"),cat_uscita[i].getAttribute("valore")])

    cat_entrata = file_pref.getElementsByTagName('cat_entrata')[0].childNodes
    for i in range (0,len(cat_entrata)):
        if cat_entrata[i].nodeType==3:
            pass
        else:
            ar_cat_entrata2.append([cat_entrata[i].getAttribute("img"),cat_entrata[i].getAttribute("nome"),cat_entrata[i].getAttribute("valore")])

    file_pref.unlink()        

    return ar_cat_uscita2,ar_cat_entrata2

ar_cat_uscita,ar_cat_entrata=Carica_Categorie()
ar_categorie=ar_cat_uscita+ar_cat_entrata
valuta=Carica_Valuta()
#ar_categorie[i][0] immagine
#ar_categorie[i][1] nome
#ar_categorie[i][2] valore: 0-spesa / 1-entrata

def Carica_Combo():
    model_combo_cat = gtk.ListStore(str)
    for value in ar_categorie:
      model_combo_cat.append( [value[1]])
    return model_combo_cat

model_combo_cat=Carica_Combo()
#FINE caricamento file categorie

class Family_cash(gtk.Window): 
    def __init__(self):
		global root

		# splashscreen  
		splash = gtk.Window()  
		splash.set_property('decorated',False)  
		intro = gtk.Image()  
		intro.set_from_file(os.path.join(root,"img","splash.png"))  
		splash.add(intro)  
		splash.show_all()  
		splash.set_position(gtk.WIN_POS_CENTER_ALWAYS)
		gobject.timeout_add(1500,self.mostra,splash)

    def mostra(self,splash):
		global root
		splash.destroy()
		super(Family_cash, self).__init__()
		self.set_size_request(800, 600)
		self.set_position(gtk.WIN_POS_CENTER)
		self.maximize()
		self.connect("destroy", self.Exit)
		self.set_title("Family Cash 1.0")
		self.icon = os.path.join(root,"img","ico_family.ico")
		self.set_icon_from_file(self.icon)        

		vbox = gtk.VBox(False, 0)
		hbox = gtk.HBox(False, 5)

		mb = gtk.MenuBar()
		self.statusbar = gtk.Statusbar()

		#inizio menu file-----------------------------------------------------
		filemenu = gtk.Menu()
		filem = gtk.MenuItem("_File")
		filem.set_submenu(filemenu)

		agr = gtk.AccelGroup()
		self.add_accel_group(agr)

		newi = new_item_menu(agr,gtk.STOCK_NEW,"<Control>N","_Nuovo","Crea un nuovo progetto","",self.statusbar)
		newi.connect("activate",self.Nuovo_File)
		filemenu.append(newi)

		openm = new_item_menu(agr,gtk.STOCK_OPEN,"<Control>O","_Apri","Apri un progetto esistente","",self.statusbar)
		openm.connect("activate",self.Apri_File)
		filemenu.append(openm)

		self.manager = gtk.recent_manager_get_default()
		recent_menu_chooser = gtk.RecentChooserMenu(self.manager)
		recent_menu_chooser.set_show_numbers(True)
		recent_menu_chooser.set_limit(10)
		recent_menu_chooser.set_sort_type(gtk.RECENT_SORT_MRU)
		recent_menu_chooser.set_show_not_found(True)
		recent_menu_chooser.set_show_tips(True)
		filter = gtk.RecentFilter()
		filter.add_pattern("*.fcx") #set this to whatever file type you want
		recent_menu_chooser.add_filter(filter)
		recent_menu_chooser.connect('item-activated', self.recent_item_activated)
		mnurecent = gtk.MenuItem("Apri recenti...")
		mnurecent.set_submenu(recent_menu_chooser)
		filemenu.append(mnurecent)

		savem = new_item_menu(agr,gtk.STOCK_SAVE,"<Control>S","_Salva","Salva il progetto aperto","",self.statusbar)
		savem.connect("activate",self.Salva_File)
		filemenu.append(savem)

		sep = gtk.SeparatorMenuItem()
		filemenu.append(sep)

		closem = new_item_menu(agr,gtk.STOCK_CLOSE,"<Control>W","_Chiudi","Chiudi il progetto aperto","",self.statusbar)
		closem.connect("activate",self.Chiudi_File)
		filemenu.append(closem)

		sep = gtk.SeparatorMenuItem()
		filemenu.append(sep)

		exit = new_item_menu(agr,gtk.STOCK_QUIT,"<Control>Q","_Esci","Esci da Family Cash","",self.statusbar)
		exit.connect("activate",self.Exit)

		exit.connect("activate", gtk.main_quit)
		filemenu.append(exit)

		#fine menu file-----------------------------------------------------

		#inizio menu edit-----------------------------------------------------
		fileedit = gtk.Menu()
		edit = gtk.MenuItem("_Edit")
		edit.set_submenu(fileedit)

		pref = new_item_menu(agr,gtk.STOCK_PREFERENCES,"<Control><Shift>P","_Opzioni","Opzioni di Family Cash","",self.statusbar)
		pref.connect("activate", self.About_Setting)
		fileedit.append(pref)
		#fine menu edit-----------------------------------------------------

		#inizio menu inserisci-----------------------------------------------------
		fileins = gtk.Menu()
		ins = gtk.MenuItem("_Inserisci")
		ins.set_submenu(fileins)

		self.ins_op = new_item_menu(agr,gtk.STOCK_ADD,"<Control>A","_Operazioni annuali","Inserisce un\'operazione per tutto l\'anno.","",self.statusbar)
		self.ins_op.connect("activate", self.Op_Annuale)
		self.ins_op.set_sensitive(False)
		fileins.append(self.ins_op)
		#fine menu inserisci-----------------------------------------------------

		#inizio menu help-----------------------------------------------------
		filehelp = gtk.Menu()
		help = gtk.MenuItem("_Help")
		help.set_submenu(filehelp)

		manuale = new_item_menu(agr,gtk.STOCK_HELP,"<Control>H","_Manuale","Manuale di Family Cash","",self.statusbar)
		manuale.connect("activate", self.About_Manuale)
		filehelp.append(manuale)

		filehelp.append(gtk.SeparatorMenuItem())

		info = new_item_menu(agr,gtk.STOCK_INFO,"<Control>I","_Info","Informazioni su Family Cash","",self.statusbar)
		info.connect("activate", self.About_Info)
		filehelp.append(info)
		#fine menu help-----------------------------------------------------

		mb.append(filem)
		mb.append(edit)
		mb.append(ins)
		mb.append(help)
		vbox.pack_start(mb, False, False, 0)
		vbox.pack_start(hbox, False, False, 0)

		#inizio toolbar-----------------------------------------------------
		self.tooltips = gtk.Tooltips()

		toolbar = gtk.Toolbar()
		toolbar.set_style(gtk.TOOLBAR_ICONS)

		newtb = gtk.ToolButton(gtk.STOCK_NEW)
		self.tooltips.set_tip(newtb, "Crea un nuovo progetto")
		newtb.connect("clicked",self.Nuovo_File)

		opentb = gtk.ToolButton(gtk.STOCK_OPEN)
		opentb.connect("clicked",self.Apri_File)
		self.tooltips.set_tip(opentb, "Apre un progetto esistente")

		savetb = gtk.ToolButton(gtk.STOCK_SAVE)
		savetb.connect("clicked",self.Salva_File)
		self.tooltips.set_tip(savetb, "Salva il progetto aperto")

		sep = gtk.SeparatorToolItem()

		closeb = gtk.ToolButton(gtk.STOCK_CLOSE)
		closeb.connect("clicked",self.Chiudi_File)
		self.tooltips.set_tip(closeb, "Chiudi il progetto aperto")

		sep2 = gtk.SeparatorToolItem()
		sep3 = gtk.SeparatorToolItem()

		quittb = gtk.ToolButton(gtk.STOCK_QUIT)
		quittb.connect("clicked",self.Exit)
		self.tooltips.set_tip(quittb, "Esci da Family Cash")

		toolbar.insert(newtb, 0)
		toolbar.insert(opentb, 1)
		toolbar.insert(savetb, 2)
		toolbar.insert(closeb, 3)
		toolbar.insert(sep, 4)
		toolbar.insert(quittb, 5)

		vbox.pack_start(toolbar, False, False, 0)
		#fine toolbar-----------------------------------------------------

		#inizio box del notebook----------------------------------------------
		self.box_nb=gtk.HBox()
		vbox.pack_start(self.box_nb, True, True, 0)
		#fine notebook----------------------------------------------

		#inizio statusbar----------------------------------------------
		self.statusbar.push(1, "")
		vbox.pack_start(self.statusbar, False, False, 0)
		#fine statusbar----------------------------------------------

		self.add(vbox)

		self.show_all()
        
    def recent_item_activated(self, widget):
        global ar_categorie
        global ar_cat_uscita
        global ar_cat_entrata
        global model_combo_cat
        global aperto
        global file_family
        global valuta
        global root

        uri = widget.get_current_item().get_uri()
        file_family = uri[7:]
        if os.path.exists(file_family):
            Carica_File(self,file_family,ar_categorie,ar_cat_uscita,ar_cat_entrata,model_combo_cat,valuta,root)
            aperto=1
            self.ins_op.set_sensitive(True)
        else:
            msg="ATTENZIONE!\n"+file_family+"\nnon esiste."
            msg_box=gtk.MessageDialog(None, 0, gtk.MESSAGE_INFO, gtk.BUTTONS_CLOSE, msg)
            response = msg_box.run()
            if response == gtk.RESPONSE_CLOSE:
                msg_box.destroy()
            else:
                pass
            msg_box.destroy()
            self.manager.remove_item(uri) 

    def Exit(self, widget, data=None):
    	Exit2()

    def Nuovo_File(self, widget):
        global ar_categorie
        global ar_cat_uscita
        global ar_cat_entrata
        global model_combo_cat
        global aperto
        global file_family
        global valuta
        global nuovo
        global root
        
        if nuovo==1:
            self.Chiudi_File(self)
            nuovo=0
            aperto=0
            esito=Nuovo_File2(self,file_family,ar_categorie,ar_cat_uscita,ar_cat_entrata,model_combo_cat,valuta,root)
            if esito==True:
                nuovo=1
                aperto=1
                self.ins_op.set_sensitive(True)
        else:
            esito=Nuovo_File2(self,file_family,ar_categorie,ar_cat_uscita,ar_cat_entrata,model_combo_cat,valuta,root)
            if esito==True:
                nuovo=1
                aperto=1
                self.ins_op.set_sensitive(True)

    def Chiudi_File(self, widget):
        global aperto
        global file_family
        
        if "*" in self.get_title():
            msg="ATTENZIONE!"
            msg_box=gtk.Dialog(msg,self,gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,(gtk.STOCK_CANCEL, gtk.RESPONSE_REJECT,gtk.STOCK_OK,gtk.RESPONSE_ACCEPT))
            testo=gtk.Label("Vuoi salvare il file\n"+file_family+"\nprima di chiuderlo?")
            msg_box.vbox.pack_start(testo, True, True, 0)
            testo.show()
            response = msg_box.run()
            if response == gtk.RESPONSE_ACCEPT:
                msg_box.destroy()
                self.Salva_File(self)
            else:
                pass
            msg_box.destroy()
                        
        Chiudi_File2(self,aperto)
        self.ins_op.set_sensitive(False)
        aperto=0
        file_family=""

    def Apri_File(self, widget):
        global ar_categorie
        global ar_cat_uscita
        global ar_cat_entrata
        global model_combo_cat
        global aperto
        global file_family
        global valuta
        global root

        if aperto==1:
            self.Chiudi_File(self)
            aperto=0
            
        file_family=Apri_File2(self,aperto,root)
        self.ins_op.set_sensitive(True)
        if file_family!=None:
            Carica_File(self,file_family,ar_categorie,ar_cat_uscita,ar_cat_entrata,model_combo_cat,valuta,root)
            aperto=1

    def Salva_File(self, widget):
        global aperto
        global nuovo
        global file_family
        global valuta
        
    	file_family=Salva_File2(self,aperto,file_family,nuovo,valuta)
    	nuovo=0

    def Op_Annuale(self, widget):
        global model_combo_cat
        global valuta
        global ar_categorie
        global ar_cat_uscita
        global ar_cat_entrata
        global root
        Op_Annuale2(self,model_combo_cat,valuta,ar_categorie,ar_cat_uscita,ar_cat_entrata,root)
        
    def About_Info(self, widget):
        global root
        About_Info2(self,root)

    def About_Setting(self, widget):
        global root
        About_Setting2(self,ar_categorie,root)

    def About_Manuale(self, widget):
        global root
        About_Manuale2(self,root)

Family_cash()
gtk.main()



