#!/usr/bin/python
# -*- coding: utf-8 -*-
__author__="Krypt"
__date__ ="$05-jen-2010 18.00.00$"

import gtk,os,sys
from mod.grafica import *
from mod.setting import *
from mod.op_anno_mese import *
#from xml.dom import minidom
#from xml.dom.minidom import Document
from datetime import date

def Op_Annuale2(self,model_combo_cat,valuta,ar_categorie,ar_cat_uscita,ar_cat_entrata,root):
	self.fin_annuale = gtk.Window(gtk.WINDOW_TOPLEVEL)

	self.fin_annuale.set_size_request(500, 400)
	self.fin_annuale.set_position(gtk.WIN_POS_CENTER)
	self.fin_annuale.set_resizable(True)
	self.fin_annuale.connect("destroy", Chiudi_Annuale,self.fin_annuale)
	self.fin_annuale.set_title("Impostazioni operazioni annuali")
	self.fin_annuale.set_icon_from_file(self.icon)        

	vbox=gtk.VBox(False, 0)

	box_bottoni=gtk.HBox()
	b_aggiungi=crea_b_img(gtk.STOCK_ADD,"Aggiungi operazione",200,40,1)
	b_togli=crea_b_img(gtk.STOCK_REMOVE,"Cancella operazione",200,40,1)
	box_bottoni.pack_start(b_aggiungi, True, False, 0)
	box_bottoni.pack_start(b_togli, True, False, 0)
	vbox.pack_start(box_bottoni, False, False, 10)

	vbox.pack_start(gtk.HSeparator(), False, False, 5)

	sw_cat = gtk.ScrolledWindow()
	sw_cat.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
	sw_cat.set_size_request(550, 250)
	tv_cat,store=Carica_Annuale(self,model_combo_cat,valuta,ar_categorie,root)
	sw_cat.add_with_viewport(tv_cat)
	vbox.pack_start(sw_cat, False, False, 0)

	vbox.pack_start(gtk.HSeparator(), False, False, 10)

	#bottoni ok e cancel
	box_btn=gtk.HBox(True, 5)
	btn_cancel=crea_b_img(gtk.STOCK_CANCEL,"Annulla",200,40,1)
	btn_cancel.connect("clicked", Chiudi_Opzioni,self.fin_annuale)
	btn_ok=crea_b_img(gtk.STOCK_OK,"OK",200,40,1)
#	btn_ok.connect("clicked", Salva_Annulla,self.fin_opzioni,tv_cat,euro)
	btn_ok.connect("clicked", Salva_Annuale,self,ar_categorie,store,ar_cat_uscita,ar_cat_entrata,valuta,root)
	box_btn.pack_start(btn_cancel, False, False, 0)
	box_btn.pack_start(btn_ok, False, False, 0)
	vbox.pack_start(box_btn, False, False, 10)

	b_aggiungi.connect("clicked", Aggiungi_Annuale,store,ar_categorie,valuta,root)
	b_togli.connect("clicked", Togli_Annuale,tv_cat,store)

	self.fin_annuale.add(vbox)
	self.fin_annuale.set_modal(True)
	self.fin_annuale.show_all()	

def Carica_Annuale(self,model_combo_cat,valuta,ar_categorie,root):
	#creo il modello dei totali
	store = gtk.ListStore(str, str, str, gtk.gdk.Pixbuf, str)	
	tv_cat = gtk.TreeView(store)
	#	tv_totali = gtk.TreeView(tms_totali)
	tv_cat.set_rules_hint(True)
	tv_cat.set_grid_lines(gtk.TREE_VIEW_GRID_LINES_BOTH)
	#creo le celle
	cell_img = gtk.CellRendererPixbuf()

	cell_combo = gtk.CellRendererCombo()
	cell_combo.set_property("text-column", 0)
	cell_combo.set_property("editable", True)
	cell_combo.set_property("has-entry", False)
	cell_combo.set_property("model", model_combo_cat)
	cell_combo.connect("edited", Aggiorna_Combo,store,ar_categorie,root)

	#creo le colonne dei totali
	cell_text = gtk.CellRendererText()
	cell_text.set_property("editable",True)
	c_giorno = gtk.TreeViewColumn("Giorno", cell_text, text=0)
	c_giorno.set_expand(True)
	cell_text.connect("edited", Aggiorna_Testo,0,valuta,store)

	cell_text = gtk.CellRendererText()
	cell_text.set_property("editable",True)
	tv_cat.append_column(c_giorno)
	c_nome = gtk.TreeViewColumn("Descrizione", cell_text, text=1)
	c_nome.set_expand(True)
	cell_text.connect("edited", Aggiorna_Testo,1,valuta,store)

	cell_text = gtk.CellRendererText()
	cell_text.set_property("editable",True)
	tv_cat.append_column(c_nome)
	c_nome = gtk.TreeViewColumn("Costo "+valuta, cell_text, text=2)
	c_nome.set_expand(True)
	cell_text.connect("edited", Aggiorna_Testo,2,valuta,store)

	tv_cat.append_column(c_nome)
	c_img = gtk.TreeViewColumn("", cell_img, pixbuf=3)
	c_img.set_expand(False)
	tv_cat.append_column(c_img)

	c_tipo = gtk.TreeViewColumn("Categoria", cell_combo, text=4)
	c_tipo.set_expand(True)
	tv_cat.append_column(c_tipo)

	return tv_cat,store

def Aggiorna_Testo(cell, path, new_text, id_col,valuta,store):

	if id_col==0:
		iter = store.get_iter(path)
		old=store.get_value(iter, id_col)
		if new_text.isdigit() and (1<=int(new_text)<=31):
			pass
		else:
			new_text=old
		
	if id_col==2:
		iter = store.get_iter(path)
		old=store.get_value(iter, id_col)
		num=Controlla_Numero(new_text)
		if num==True:
			new_text=Arrotonda(new_text,valuta)
		else:
			new_text=old

	store[path][id_col] = (new_text)

def Aggiorna_Combo(cellrenderertext, path, new_text, store,ar_categorie,root):

	iter = store.get_iter(path)
	store.set_value(iter, 4, new_text)

	for i in range (0, len(ar_categorie)):
		if ar_categorie[i][1]==new_text:
			new_img = gtk.gdk.pixbuf_new_from_file(os.path.join(root,"img",ar_categorie[i][0]))
			store.set_value(iter, 3, new_img)

def Aggiungi_Annuale(widget,store,ar_categorie,valuta,root):
	
	giorno="1"
	descrizione=""
	euro=valuta+" 0.00"
	categoria=ar_categorie[0][1]
	img_cat = gtk.gdk.pixbuf_new_from_file(os.path.join(root,"img",ar_categorie[0][0]))
	store.append([giorno,descrizione,euro, img_cat,categoria])

def Togli_Annuale(widget,tv_cat,store):
	try:
		model,iter = tv_cat.get_selection().get_selected()
		store.remove(iter)
	except TypeError:
		crea_avviso("Seleziona un'operazione da cancellare")

def Salva_Annuale(widget,self,ar_categorie,store,ar_cat_uscita,ar_cat_entrata,valuta,root):

	img_cal = gtk.gdk.pixbuf_new_from_file(os.path.join(root,"img","ico_calendario.png"))
	data_odierna=date.today()

	pag_tot=self.notebook.get_nth_page(0)
	tms_totali=pag_tot.get_children()[0].get_children()[0].get_model()

	for a in xrange(1,13):

		pag=self.notebook.get_nth_page(a)
		store_mese=pag.get_children()[1].get_children()[0].get_children()[0].get_model()

		row_num=0
		for row in store:
			iter = store.get_iter(row_num)	
			descrizione = store.get_value(iter, 1)
			euro = store.get_value(iter, 2)
			categoria = store.get_value(iter, 4)
			img_cat=Recupera_Ico(categoria,ar_categorie,root)
			data = (str(store.get_value(iter, 0))+"/"+str(a)+"/"+str(data_odierna.year))

			store_mese.get_model().append([img_cal,data,descrizione,euro,img_cat,categoria])
			row_num=row_num+1

		Aggiorna_Totali(a,tms_totali,ar_cat_uscita,ar_cat_entrata,valuta,self.notebook)
	
	
	
def Chiudi_Annuale(self,fin):
    fin.set_modal(False)
    fin.destroy()
	
