#!/usr/bin/python
# -*- coding: utf-8 -*-
__author__="Krypt"
__date__ ="$05-jen-2010 18.00.00$"

import gtk,os,sys
from xml.dom import minidom
from xml.dom.minidom import Document
from datetime import date
from mod.op_anno_mese import *

def Exit2():
    return gtk.main_quit()

def Nuovo_File2(self,file_family,ar_categorie,ar_cat_uscita,ar_cat_entrata,model_combo_cat,valuta,root):

	icon =os.path.join("img","ico_family.ico")
	data_odierna=date.today()

	dlg=gtk.Dialog("Nuovo progetto", None, gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,(gtk.STOCK_CANCEL, gtk.RESPONSE_REJECT,gtk.STOCK_OK, gtk.RESPONSE_ACCEPT))
	dlg.set_size_request(200,100)
	dlg.set_resizable(False)
	dlg.set_deletable(False)
	dlg.set_icon_from_file(os.path.join(root,"img","ico_family.ico"))
	
	box_anno=gtk.HBox()
	label_testo=gtk.Label("Scegli l'anno")
	anno=gtk.Entry()
	anno.set_text(str(data_odierna.year))
	anno.set_width_chars(4)
	anno.set_max_length(4)
	box_anno.pack_start(label_testo, False, False, 5)
	box_anno.pack_start(anno, False, False, 5)


	dlg.vbox.pack_start(box_anno, False, False, 5)

	dlg.show_all()
	response = dlg.run()
	if response == gtk.RESPONSE_ACCEPT:
		if anno.get_text().isdigit():
			esito=True
			Carica_Struttura(dlg,self,anno,file_family,ar_categorie,ar_cat_uscita,ar_cat_entrata,model_combo_cat,valuta,root)
		else:
			crea_avviso("Devi digitare l'anno di partenza")
			esito=False
		
	elif response == gtk.RESPONSE_REJECT:
		esito=False
		dlg.destroy()

	dlg.destroy()
	return esito  

def Carica_Struttura(widget,self,anno,file_family,ar_categorie,ar_cat_uscita,ar_cat_entrata,model_combo_cat,valuta,root):

    if anno.get_text().isdigit():

        self.notebook = gtk.Notebook()
        self.notebook.set_tab_pos(gtk.POS_TOP)
        self.box_nb.pack_start(self.notebook, True, True, 0)

        self.label_anno = gtk.Label("Anno "+anno.get_text())

        sw_totali = gtk.ScrolledWindow()
        sw_totali.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        self.notebook.append_page(sw_totali, self.label_anno)

        #creo il modello dei totali
        store_totali = Modello_Store(0)
        tms_totali = gtk.TreeModelSort(store_totali)
        tv_totali = gtk.TreeView(tms_totali)
        tv_totali.set_rules_hint(True)
        #creo le colonne dei totali
        Colonne_Totali(tv_totali)
        Popola_Totali(store_totali,file_family,ar_categorie,ar_cat_uscita,ar_cat_entrata,valuta,root)

        sw_totali.add_with_viewport(tv_totali)
        
        ar_mesi=["Gennaio","Febbraio","Marzo","Aprile","Maggio","Giugno","Luglio","Agosto","Settembre","Ottobre","Novembre","Dicembre"]
        for a in xrange (0,12):
            label_mese = gtk.Label(ar_mesi[a])
            #creo il modello del mese
            store_mese = Modello_Store(1)
            tms_mese = gtk.TreeModelSort(store_mese)
            tv_mese = gtk.TreeView(tms_mese)
            tv_mese.set_rules_hint(True)
            tv_mese.connect('cursor-changed', Scegli_Data,root)

            box_bottoni=gtk.HBox()
            b_aggiungi=crea_b_img(gtk.STOCK_ADD,"Aggiungi operazione",200,40,1)
            b_aggiungi.connect("clicked", Aggiungi_Operazione,store_mese,ar_categorie,valuta,self,file_family,root)
#            b_aggiungi.connect("clicked", Aggiungi_Operazione,store_mese,ar_categorie)
            b_togli=crea_b_img(gtk.STOCK_REMOVE,"Cancella operazione",200,40,1)
            b_togli.connect("clicked", Togli_Operazione,tv_mese,tms_mese,store_mese,tms_totali,tv_totali,ar_cat_uscita,ar_cat_entrata,self.notebook,valuta,self,file_family)
    #            b_togli.connect("clicked", Togli_Operazione,tv_mese,tms_mese,store_mese)
            box_bottoni.pack_start(b_aggiungi, False, False, 0)
            box_bottoni.pack_start(b_togli, False, False, 0)

            box_mese=gtk.VBox()
            box_mese.pack_start(box_bottoni, False, False, 0)
            sw_mese = gtk.ScrolledWindow()
            sw_mese.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
            box_mese.pack_start(sw_mese, True, True, 0)
            self.notebook.append_page(box_mese, label_mese)

            Colonne_Mese(tv_mese,ar_categorie,ar_cat_uscita,ar_cat_entrata,tms_mese,model_combo_cat,self.notebook,tms_totali,tv_totali,valuta,self,file_family,root)
            sw_mese.add_with_viewport(tv_mese)

        self.notebook.show_all()

        self.set_title("Family Cash 1.0 - *Nuovo")
    
    
def Chiudi_File2(self,aperto):

    if aperto==0:
        pass
    else:
        self.notebook.destroy()
        self.set_title("Family Cash 1.0")

def Apri_File2(self,aperto,root):
    fin = gtk.FileChooserDialog("Apri progetto...",None,gtk.FILE_CHOOSER_ACTION_OPEN,(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK))
    fin.set_default_response(gtk.RESPONSE_OK)
    fin.set_transient_for(self)
    fin.set_current_folder(os.path.join(root,"progetti"))
    fin.set_position(gtk.WIN_POS_CENTER_ON_PARENT)
    fin.set_icon_from_file(self.icon)        
    filter = gtk.FileFilter()
    filter.set_name("Family Cash")
    filter.add_pattern("*.fcx")
    fin.add_filter(filter)
    filter = gtk.FileFilter()
    filter.set_name("Tutti i file")
    filter.add_pattern("*")
    fin.add_filter(filter)
    response = fin.run()

    if response == gtk.RESPONSE_OK:
        archivio_temp = fin.get_filenames()
        file_family=archivio_temp[0]

        self.manager = gtk.recent_manager_get_default()
        self.manager.add_item("file://" + file_family)

    elif response == gtk.RESPONSE_CANCEL:
        file_family=None
        fin.destroy()
    fin.destroy()
    return file_family
    
def Salva_Come(self):
    fin = gtk.FileChooserDialog("Salva il nuovo progetto...",None,gtk.FILE_CHOOSER_ACTION_SAVE,(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,gtk.STOCK_SAVE,gtk.RESPONSE_OK))
    fin.set_default_response(gtk.RESPONSE_OK)
    fin.set_transient_for(self)
    fin.set_current_folder(os.path.join("progetti"))
    fin.set_position(gtk.WIN_POS_CENTER_ON_PARENT)
    fin.set_icon_from_file(self.icon)        
    filter = gtk.FileFilter()
    filter.set_name("Family Cash")
    filter.add_pattern("*.fcx")
    fin.add_filter(filter)
    filter = gtk.FileFilter()
    filter.set_name("Tutti i file")
    filter.add_pattern("*")
    fin.add_filter(filter)
    response = fin.run()

    if response == gtk.RESPONSE_OK:
        archivio_temp = fin.get_filenames()
        file_family=archivio_temp[0]
        if os.path.splitext(file_family)[1]=="":
            file_family=file_family+".fcx"

        self.manager = gtk.recent_manager_get_default()
        self.manager.add_item("file://" + file_family)

    elif response == gtk.RESPONSE_CANCEL:
        file_family=None
        fin.destroy()
    fin.destroy()
    self.set_title("Family Cash 1.0 - "+file_family)
    return file_family
    
def Salva_File2(self,aperto,file_family,nuovo,valuta):

    if nuovo==1:
        file_family=Salva_Come(self)
        
    if aperto==1 and file_family!=None:

        doc = Document()

        anno = doc.createElement("anno")
        anno.setAttribute("nome", self.label_anno.get_text())
        doc.appendChild(anno)
        
        mesi = doc.createElement("mesi")
        anno.appendChild(mesi)

        for x in xrange(1,13):

            pag=self.notebook.get_nth_page(x)
            nome_mese=self.notebook.get_tab_label(pag).get_text()

            mese = doc.createElement("mese")
            mese.setAttribute("nome", nome_mese)
            mesi.appendChild(mese)

            tm=pag.get_children()[1].get_children()[0].get_children()[0].get_model()
            num_row=0
            for row in tm:
                operazione = doc.createElement("operazione")
                operazione.setAttribute("data", tm[num_row][1])
                operazione.setAttribute("descrizione", tm[num_row][2])
                operazione.setAttribute("costo", str(Togli_Valuta(tm[num_row][3],valuta)))
                operazione.setAttribute("categoria", tm[num_row][5])
                mese.appendChild(operazione)
                num_row=num_row+1

        file_family_temp = open(file_family,'w')
        file_family_temp.write(doc.toprettyxml(indent="  "))
        file_family_temp.close()
    	self.set_title("Family Cash 1.0 - "+file_family)

    return file_family



